// Copyright AudioKit. All Rights Reserved. Revision History at http://github.com/AudioKit/AudioKit/
// This file was auto-autogenerated by scripts and templates at http://github.com/AudioKit/AudioKitDevTools/

import AVFoundation
import AudioKit
import AudioKitEX
import CAudioKitEX

/// An automatic wah effect, ported from Guitarix via Faust.
public class AutoWah: Node {

    let input: Node

    /// Connected nodes
    public var connections: [Node] { [input] }

    /// Underlying AVAudioNode
    public var avAudioNode = instantiate(effect: "awah")

    // MARK: - Parameters

    /// Specification details for wah
    public static let wahDef = NodeParameterDef(
        identifier: "wah",
        name: "Wah Amount",
        address: akGetParameterAddress("AutoWahParameterWah"),
        defaultValue: 0.0,
        range: 0.0 ... 1.0,
        unit: .percent)

    /// Wah Amount
    @Parameter(wahDef) public var wah: AUValue

    /// Specification details for mix
    public static let mixDef = NodeParameterDef(
        identifier: "mix",
        name: "Dry/Wet Mix",
        address: akGetParameterAddress("AutoWahParameterMix"),
        defaultValue: 1.0,
        range: 0.0 ... 1.0,
        unit: .percent)

    /// Dry/Wet Mix
    @Parameter(mixDef) public var mix: AUValue

    /// Specification details for amplitude
    public static let amplitudeDef = NodeParameterDef(
        identifier: "amplitude",
        name: "Overall level",
        address: akGetParameterAddress("AutoWahParameterAmplitude"),
        defaultValue: 0.1,
        range: 0.0 ... 1.0,
        unit: .percent)

    /// Overall level
    @Parameter(amplitudeDef) public var amplitude: AUValue

    // MARK: - Initialization

    /// Initialize this autoWah node
    ///
    /// - Parameters:
    ///   - input: Input node to process
    ///   - wah: Wah Amount
    ///   - mix: Dry/Wet Mix
    ///   - amplitude: Overall level
    ///
    public init(
        _ input: Node,
        wah: AUValue = wahDef.defaultValue,
        mix: AUValue = mixDef.defaultValue,
        amplitude: AUValue = amplitudeDef.defaultValue
        ) {
        self.input = input

        setupParameters()

        self.wah = wah
        self.mix = mix
        self.amplitude = amplitude
   }
}
